/* Copyright 2008-2011 Research Foundation State University of New York   */

/* This file is part of QUB Express.                                      */

/* QUB Express is free software; you can redistribute it and/or modify    */
/* it under the terms of the GNU General Public License as published by   */
/* the Free Software Foundation, either version 3 of the License, or      */
/* (at your option) any later version.                                    */

/* QUB Express is distributed in the hope that it will be useful,         */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of         */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          */
/* GNU General Public License for more details.                           */

/* You should have received a copy of the GNU General Public License,     */
/* named LICENSE.txt, in the QUB Express program directory.  If not, see  */
/* <http://www.gnu.org/licenses/>.                                        */

#ifndef QUB_DOSERESPONSE_H
#define QUB_DOSERESPONSE_H

#include "qubfast.h"

#ifdef __cplusplus
extern "C" {
#endif

QUBFAST_API void* qub_doseresponse_equil_init(int Ntail, float dy);
  // Creates a dose-response measurer
QUBFAST_API void qub_doseresponse_equil_free(void *dr);
  // Frees a dose-response measurer
QUBFAST_API void qub_doseresponse_equil_add_data(void *dr, int Ndata, float *stim, float *resp);
  // Feeds a chunk of data to the measurer; you must feed chunks in reverse order (though inside the chunk it is forward order)
QUBFAST_API int qub_doseresponse_equil_result(void *dr, int max_results, float *dose, float *resp, float *resp_std);
  // Fills in up to max_results dose-response datapoints; returns the actual number


QUBFAST_API void* qub_doseresponse_peak_init(double sampling, double filter_kHz, double sign);
  // Creates a dose-response measurer
QUBFAST_API void qub_doseresponse_peak_free(void *dr);
  // Frees a dose-response measurer
QUBFAST_API void qub_doseresponse_peak_add_data(void *dr, int Ndata, float *stim, float *resp);
  // Feeds a chunk of data to the measurer; you must feed chunks in reverse order (though inside the chunk it is forward order)
QUBFAST_API int qub_doseresponse_peak_result(void *dr, int max_results, float *dose, float *resp);
  // Fills in up to max_results dose-response datapoints; returns the actual number


#ifdef __cplusplus
}
#endif

#endif
